/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#ifndef MIDI_LIB_H
#define MIDI_LIB_H

#include "basic_types.h"
#include "Rogus.h"
#include "MidiMsg.h"

//--------------------------------------------------------------------------------------------------

class MIDI_msg : public MidiMsg
{
public:
	ioref node; // 2
	
	MIDI_msg() { node = 0; }
	MIDI_msg(const MIDI_msg& m) { operator=(m); }

	bool is_on_for( const MIDI_msg& m ) const;

	void to_OMS( DWORD* p, UINT* n ) const;
	void fr_OMS( DWORD p1, DWORD p2, UINT n );

	void set( int msgt, int lsn, int dat1, int dat2, int node );
	
	bool operator==(const MIDI_msg& m)
	{
		return ((node == m.node) &&
				  ((*((MidiMsg*)this)) == (*((MidiMsg*)(&m)))));
	}
	MIDI_msg& operator=(const MIDI_msg& m)
	{
		(*((MidiMsg*)this)) = (*((MidiMsg*)(&m)));
		node = m.node;
		return (*this);
	}
};
/*
2. Occasionally I wonder whether it would be more useful for this to be appconRefcon rather
than srcIORefNum for inputs.
*/

//--------------------------------------------------------------------------------------------------

class parser
{
public:
	typedef void (*handlerp)( MIDI_msg* );
		
	handlerp msg_hnd[8]; // handlers for the basic message types
 
	parser();
	void parse( DWORD p1, DWORD p2, UINT n ) { MIDI_msg m; m.fr_OMS(p1,p2,n); msg_hnd[m.msgt()](&m); }
	bool handles( DWORD p ) { return msg_hnd[  MIDI_msg::msgt((unsigned char) (p & 0xff))  ] != NULL; }
	virtual ~parser();
};

#endif
// Author: Ben Denckla

