/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#ifndef ERR_AND_WARN_H
#define ERR_AND_WARN_H

#include "text_win.h"

enum err_ind { no_err, err };

class err_and_warn
{
private:
	enum { ALRT_error = 129 };
	text_win *tw;
	
public:
	class err {};

	err_and_warn() { tw = 0; } // null tw shows that the window is not ready
	void init( text_win *in_tw ) { tw = in_tw; }
	void e( const char *format, ... ); // error: post message in alert and exit program
	void a( const char *format, ... ); // alert: post message in alert
	void w( const char *format, ... ); // warning: write message in text window
};

extern err_and_warn ew;

#endif
// Author: Ben Denckla
