/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#ifndef UTILARRAY_H
#define UTILARRAY_H

#include "basic_types.h"

template <class T>
class UtilArray
{
#ifndef min
	static int min(int a, int b) { return ((a>b) ? b : a); }
#endif
	elements_match(T* x) const { for (int i = 0; i < length; i++) if (!(p[i] == x[i])) return 0; return 1; }
protected:
	T* p;
public:
	const int length;
	UtilArray(int l) : length((l < 0) ? 0 : l) { p = new T[(l < 1) ? 1 : l]; }
	~UtilArray() { delete[] p; }
	UtilArray<T>& operator=(const UtilArray<T>& x) { for (int i = 0; i < min(length, x.length); i++) p[i] = x.p[i]; return *this; }
	bool operator==(const UtilArray<T>& x) const { return (length == x.length && elements_match(x.p)); }
	T& operator[](int i) { return p[(i < 0) ? 0 : ((i >= length) ? ((length == 0) ? 0 : length-1) : i)]; }
};

#endif
// Author: Patrick Pelletier
