/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#ifndef RECORDER_H
#define RECORDER_H

#include "UtilPtr.h"
//#include "Filedata.h"
#include "MIDI_lib.h"
#include "LPeriodical.h"

class Recorder : LPeriodical {
	friend class Score;
	struct storage_group {
		enum { group_size = 100 };
		
		MIDI_msg msgs[group_size];
		storage_group* next;
		
		storage_group() { next = NULL; }
		~storage_group() { if (next != NULL) delete next; next = NULL; }
		MIDI_msg& operator[](int i)
		{
			if (i < group_size)
				return msgs[i]; // base case
			else
				return (*next)[i-group_size]; // cute tail-recursive trick
		}
	};
	
	typedef UtilArray<MidiMsg> MidiMsgArray;
	typedef UtilPtr<MidiMsgArray> MidiMsgArrayPtr;
	typedef UtilArray<MidiMsgArrayPtr> MidiMsgArrayPtrArray;
	typedef UtilPtr<MidiMsgArrayPtrArray> MidiMsgArrayPtrArrayPtr;
	typedef UtilPtr<storage_group> storage_groupPtr;
	enum { desired_free = 30 };
	
	storage_groupPtr first;
	storage_group* last;
	int groups_free;
	storage_group* current;
	int current_base_index;
	int current_index;
	int overflow;

	MIDI_msg& index(int i)
	{
		if (i > current_base_index)
			return (*current)[i-current_base_index];
		else
			return (*first)[i];
	}
	void SpendTime(const EventRecord&);
public:
//	typedef UtilPtr<Filedata> FiledataPtr;
	Recorder();
	~Recorder();
	void insert(const MIDI_msg*);
	void setAutoRecord(bool);
	bool getAutoRecord();
//	FiledataPtr capture();
};

#endif
// Author: Patrick Pelletier
